Attribute VB_Name = "mt94subs"
Sub taaltekst()
'standaard teksten

'menu items 30 gereserveerd
teksten$(1) = "File"  'bestand
teksten$(2) = "Open File"  'open bestand
teksten$(3) = "Save html"
teksten$(4) = "Save csv"
teksten$(5) = "Print"
teksten$(6) = "Close"
teksten$(7) = "Setup"
teksten$(8) = "Currency / numbers"
teksten$(9) = "Help"
teksten$(10) = "About"
teksten$(11) = "Create bank statement"
teksten$(12) = "Set language"
teksten$(13) = "OK"
teksten$(14) = "Cancel"
teksten$(15) = "Amount style"
teksten$(16) = "Date style"
teksten$(17) = "Scroll modus"
teksten$(18) = "dd-mm-yyyy"
teksten$(19) = "mm-dd-yyyy"

'open/save dialoog
teksten$(31) = "Open MT940 file"
teksten$(32) = "MT940 files"
teksten$(33) = "Save as html file"
teksten$(34) = "html files"
teksten$(35) = "Save as csv file"
teksten$(36) = "csv files"

'afschrift
teksten$(40) = "Bank statement"
teksten$(41) = "Opening balance at"
teksten$(42) = "Closing balance at"
teksten$(43) = "Bank account number"
teksten$(44) = "Statement number"
teksten$(45) = "Ammount"
teksten$(46) = "val.date"
teksten$(47) = "entry.date"
teksten$(48) = "Details"

'over scherm
teksten$(50) = "Programmer"
teksten$(51) = "This program is open-source. For more information about the creator and for other programs go to"
'taal venster
teksten$(52) = "Language"
teksten$(53) = "Select your language"
'scrol venster
teksten$(54) = "Select a directory with Mt940 files :"
teksten$(55) = "last"
teksten$(56) = "next"
teksten$(57) = "Scroll end"




'meldingen
teksten$(60) = "No records available"
teksten$(61) = "First file reached"
teksten$(62) = "Last file reached"


'help
teksten$(70) = "General"
teksten$(71) = "General purpose of this program is to read bankstatement information in the widely used MT940 files. MT940 files aren't very easy to read. With this program you can make html bankstatementfiles, print bankstatements and export to csv files."
teksten$(72) = "How to?"
teksten$(73) = "Open a MT940 files directly with open file or scroll through a folder containing multiple MT940 files with the scroll modus. In case of opening a single file you have to press 'make bankstatement' to view the bankstatement on screen."
teksten$(74) = "If a MT940 file has been selected you can print  the bankstatement by pressing 'print'" + Chr$(44) + " save als 'html' by pressing the 'save as html' button or save as csv file."
teksten$(75) = "Problems?"
teksten$(76) = "All banks have there own interpretation of the MT940 specifications. Since this program is based on available sample files there might be a change that some files doesn't work properly. In that case please provide me with a sample file (developer@coenmartinus.nl)."





'open taal bestand


'!!!!!!!!!!!!!!!!!!
'insteltaal$ = "" 'TIJDELIJK




If insteltaal$ <> "" Then
    bestnr = FreeFile
    bt$ = App.Path + "\" + insteltaal$
    hb$ = ""
    Open bt$ For Binary As bestnr
        Do
        bg$ = Space(1)
        Get bestnr, , bg$
        If bg$ <> Chr$(13) Then 'return
            If bg$ <> Chr$(10) Then hb$ = hb$ + bg$ 'negeer nw regel
            '
        Else
            If Mid(hb$, 1, 1) = "<" And Mid(hb$, 4, 1) = ">" Then
                tnr% = Val(Mid(hb$, 2, 2))
                tt$ = Mid(hb$, 5, Len(hb$) - 4)
                teksten$(tnr%) = tt$
            End If
            '
            hb$ = ""
                
        End If
          
        
        
        Loop Until EOF(bestnr)
    Close bestnr
End If





'toewijzen menu en knoppen
hoofdscherm.bestandopen.Caption = teksten$(1)
hoofdscherm.openbestand.Caption = teksten$(2)
hoofdscherm.savehtml.Caption = teksten$(3)
hoofdscherm.savecsv.Caption = teksten(4)
hoofdscherm.maakafschriftmenu.Caption = teksten(11)
hoofdscherm.printen.Caption = teksten$(5)
hoofdscherm.Einde.Caption = teksten$(6)

hoofdscherm.setup.Caption = teksten$(7)
hoofdscherm.Taal.Caption = teksten$(12)
hoofdscherm.bedragstijlmenu.Caption = teksten$(15)
hoofdscherm.datumstijlmenu.Caption = teksten$(16)
hoofdscherm.datumstijl1.Caption = teksten$(18)
hoofdscherm.datumstijl2.Caption = teksten$(19)

hoofdscherm.Over.Caption = teksten$(10)

hoofdscherm.afdrukknop.Caption = teksten$(5)
hoofdscherm.maakafschr.Caption = teksten$(11)
hoofdscherm.savhtml.Caption = teksten(3)
hoofdscherm.Savcsv.Caption = teksten(4)

hoofdscherm.scrollinks.Caption = teksten$(55)
hoofdscherm.scrolrechts.Caption = teksten$(56)
hoofdscherm.scroleinde.Caption = teksten$(57)
hoofdscherm.scrollmodus.Caption = teksten$(17)

End Sub
Sub leesmt940(bestandin$)

h = FreeFile

maxlijn% = 30000 'maximaal aantal regels lezen

Open bestandin$ For Binary As h


hulp$ = ""
lijnnr% = 0
For t = 1 To LOF(h)

a$ = " "
Get h, , a$
If a$ = Chr$(10) Then 'nieuwe lijn
    On Error Resume Next
    regels(lijnnr%) = Left(hulp$, Len(hulp$) - 1)
    hulp$ = ""
    lijnnr% = lijnnr% + 1
Else
    hulp$ = hulp$ + a$
End If

If lijnnr% = maxlijn% Then

    Close h
    Exit Sub
End If

Next t


regels(lijnnr%) = hulp$ 'laatste record

Close h


End Sub


Sub maakafschrift(optie%)
'optie 0 'maak afschrift
'optie 1 'maak html om op te slaan
'optie 2 'maak csv om op te slaan



Select Case optie%
    Case 0
        bestand$ = App.Path + "/tempmt940.htm"
    Case 1, 2
        bestand$ = hoofdscherm.Opensave.FileName
End Select

If Dir(bestand$) <> "" Then Kill (bestand$)


'indien optie 2, csv: open bestand om weg te schrijven
If optie% = 2 Then
    csvbes = FreeFile
    
    Open bestand$ For Binary As csvbes
End If



If optie% = 0 Or optie% = 1 Then
    Call openhtml(bestand$)

    Call headeraan
    Call headeruit
    Call bodyaan

    Call vetaan
    Call uitlijning(centreer)

    hulpt$ = "*** " + teksten$(40) + " ***"
    Call paragraaf(hulpt$)
    Call vetuit

    Call uitlijning(links)

    Call legeregel
End If


'vaststellen bank
If lijnnr% > 0 Then
    hulp$ = regels(0)
    bank% = 0  '0 standaard

    If Len(hulp$) > 7 And Mid(hulp$, 1, 8) = "ABNANL2A" Then bank% = 1 'abnamro
    If Len(hulp$) > 15 And Mid(hulp$, 8, 8) = "INGBNL2A" Then bank% = 2 'ing/postbank
    If Len(hulp$) > 15 And Mid(hulp$, 8, 8) = "PSTBNL21" Then bank% = 2 'ing/postbank
End If


tel% = 0
modus = 1 'header

If optie% = 2 Then  'header csv
    naarcsv$ = teksten$(43) + Chr$(59) + teksten$(44) + Chr$(59) + teksten(41) + Chr$(59) + "D/C" + Chr$(59) + teksten$(42) + Chr$(59) + "D/C" + Chr$(59) + teksten$(46) + Chr$(59) + teksten$(47) + Chr$(59) + "D/C" + Chr$(59) + teksten$(45) + Chr$(59) + teksten$(48) + Chr$(13) + Chr$(10)
    Call schrijfcsvweg(naarcsv$)
End If



Do
    'header
    hulp$ = regels(tel%)
    If Len(hulp$) >= 4 Then
        b$ = Mid(hulp$, 1, 4)
        Select Case modus
            Case 1   'op zoek naar rekening nummer
                If b$ = ":25:" Then
                    t% = Len(hulp$)
                
                    reknr$ = Mid(hulp$, 5, t% - 4)
                    modus = 2
                Else
                    tel% = tel% + 1
                End If
            Case 2  ' op zoek naar volgnummer
                If b$ = ":28:" Or b$ = ":28C" Then
                    t% = Len(hulp$)
                
                    'bij postbank/ing is de code :28C, dus indien dit het geval is middels hulpcode volgnr$ string aanpassen
                    If b$ = ":28C" Then help% = 1 Else help% = 0
                
                    volgnr$ = Mid(hulp$, 5 + help%, t% - (4 + help%))
                    modus = 3
                
                    If optie% = 0 Or optie% = 1 Then
                        Call tabelaan(1, "l")
                        Call rijaan
                        Call vetaan
                        hulpt$ = teksten$(43) + ":"
                        Call data(hulpt$, "300")
                        Call vetuit
                        Call data(reknr$, "300")
                        Call vetaan
                        hulpt$ = teksten$(44) + ":"
                        Call data(hulpt$, "200")
                        Call vetuit
                        Call data(volgnr$, "400")
                        Call rijuit
                    Else
                    naarcsv$ = Chr$(34) + reknr$ + Chr$(34) + Chr$(59) + Chr$(34) + volgnr$ + Chr$(34) + Chr$(59)
                    End If
                
                
                Else
                    tel% = tel% + 1
                End If
            Case 3 'op zoek naar beginsaldo
                If b$ = ":60F" Then
                    datum$ = convdatum$(Mid(hulp$, 7, 6))
                    debcred$ = Mid(hulp$, 6, 1)
                    valuta$ = Mid(hulp$, 13, 3)
                    bedrag$ = Mid(hulp$, 16, Len(hulp$) - 16)
                    If optie% = 0 Or optie% = 1 Then bedrag$ = convbedrag$(bedrag$) 'bedrag formatten
                     
                     
                    modus = 4
                    verdertel% = tel%
                    
                    If optie% = 0 Or optie% = 1 Then
                        Call rijaan
                        Call vetaan
                        Call data(teksten$(41), "300") 'openingsbalans
                        Call vetuit
                        Call data(datum$, "200")
                        Call data(valuta$, "100")
                        hlp$ = bedrag$ + " " + debcred$
                        Call uitlijning(rechts)
                        Call data(hlp$, "400")
                        Call uitlijning(links)
                        Call rijuit
                    Else
                        bedrag$ = Replace(bedrag$, ".", Chr$(44))
                        naarcsv$ = naarcsv$ + Chr$(34) + bedrag$ + Chr$(34) + Chr$(59) + Chr$(34) + debcred$ + Chr$(34) + Chr$(59)
                        
                    End If
                    
                Else
                    tel% = tel% + 1
                End If
            
            Case 4 'op zoek naar eindsaldo
            If b$ = ":62F" Then
                    datum$ = convdatum$(Mid(hulp$, 7, 6))
                    debcred$ = Mid(hulp$, 6, 1)
                    valuta$ = Mid(hulp$, 13, 3)
                    bedrag$ = Mid(hulp$, 16, Len(hulp$) - 16)
                    If optie% = 0 Or optie% = 1 Then bedrag$ = convbedrag$(bedrag$) 'bedrag formatten
                     
                    modus = 5
                    oudtel% = tel% 'bewaar laatste record
                    tel% = verdertel% 'zet tel% weer terug voor transacties
                    
                    If optie% = 0 Or optie% = 1 Then
                        Call rijaan
                        Call vetaan
                        Call data(teksten$(42), "300")
                        Call vetuit
                        Call data(datum$, "200")
                        Call data(valuta$, "100")
                        hlp$ = bedrag$ + " " + debcred$
                        Call uitlijning(rechts)
                        Call data(hlp$, "400")
                        Call uitlijning(links)
                        Call rijuit
                        Call tabeluit
                    
                        Call startlinks
                        Call legeregel
                        Call legeregel
                    
                        Call tabelaan(1, "l")
                        Call rijaan
                        Call tabelkop(teksten$(46), "75") 'val datum
                        Call tabelkop(teksten$(47), "75") 'boek datum
                        Call tabelkop("D/C", "40") 'd/c
                        Call tabelkop(teksten$(45), "150") 'bedrag
                        Call tabelkop(teksten$(48), "300") 'mededeling
                    
                        Call rijuit
                    Else
                        
                        
                        bedrag$ = Replace(bedrag$, ".", Chr$(44))
                        naarcsv$ = naarcsv$ + Chr$(34) + bedrag$ + Chr$(34) + Chr$(59) + Chr$(34) + debcred$ + Chr$(34) + Chr$(59) '+ Chr$(13) + Chr$(10)
                        'Call schrijfcsvweg(naarcsv$)
                        kop$ = naarcsv$
                        
                    End If
                                 
                    
                Else
                    tel% = tel% + 1
                End If
            
            
            Case 5
                If b$ = ":61:" Then
                'mededeling
                help% = 0
                locref% = 0
                
                'eerst testen of er geen spatie na code staat 'bij ING/postbank gezien
                If Mid(hulp$, 5, 1) = " " Then help% = -1
                
                'haal valuta datum op en converteer deze
                valdatum$ = convdatum$(Mid(hulp$, 5 - help%, 6))
                
                'eerst testen of er een boekdatum is opgenomen:
                If Not Asc(Mid(hulp$, 11 - help%, 1)) > 58 Then 'er is ook een boekdatum
                    boekdata$ = convboekdatum(Mid(hulp$, 11 - help%, 4))
                    
                Else    'er is geen boekdatum
                    help% = help% + 4
                    boekdata$ = Mid(valdatum, 1, 5)
                End If
                    
                debcred$ = Mid(hulp$, 15 - help%, 1)
                'test of er sprake is van een reversal
                If debcred$ = "R" Then
                    debcred$ = Mid(hulp$, 15 - help%, 2)
                    help% = help% - 1
                End If
                
                
                
                
                'test of valutacode aan staat
                               
                
                sl% = 16 - help%
                If Asc(Mid(hulp$, sl%, 1)) < 48 Or Asc(Mid(hulp$, sl%, 1)) > 57 Then 'er is een valutacode van 1 positie
                    sl% = sl% + 1 'die positie negeren
                
                End If
                
                
                
                
                bedrag$ = ""
                Do
                If Mid(hulp$, sl%, 1) <> "N" And Mid(hulp$, sl%, 1) <> "F" Then
                    bedrag$ = bedrag$ + Mid(hulp$, sl%, 1)
                    locref% = sl%
                    sl% = sl% + 1
                Else
                    Exit Do
                End If
                    
                
                Loop Until sl% >= Len(hulp$)
                
                If optie% = 0 Or optie% = 1 Then bedrag$ = convbedrag$(bedrag$)
                
                If locref% > 0 Then
                    soorttran$ = Mid(hulp$, locref% + 1, 3)
                    start% = locref% + 5
                Else
                    start% = 31
                    
                End If
                
                
                If bank% = 2 Then           'correctie bij ING en Postbank
                    start% = start% - 1
                    soorttran$ = Mid(soorttran$, 1, 2)
                End If
                
                'hoofdscherm.Label1.Caption = start%
                
                'controleer of er een tegenrekening is
                beplen% = Len(hulp$) 'lengte hulp$
                If beplen% > start% Then
                    maxlen% = beplen% - start% + 1
                    If maxlen% > 16 Then maxlen% = 16
                    tegrek$ = RTrim(Mid(hulp$, start%, maxlen%)) + " "
                Else
                    tegrek$ = ""
                End If
                    
                If tegrek$ = "NONREF " Then tegrek$ = "" 'indien geen referentie dan lege string
                
                
                'controleer of er een naam is
                If beplen% > start% + 16 Then
                    maxlen% = beplen% - (start% + 16) + 1
                    If maxlen% > 34 Then maxlen% = 34
                    tegreknaam$ = RTrim(Mid(hulp$, start% + 16, maxlen%)) + " "
                Else
                    tegreknaam$ = ""
                End If
                    
                
                
                
                
                
                omschrijving$ = tegrek$ + tegreknaam$
                hulp$ = regels(tel% + 1)
                
                If Mid(hulp$, 1, 4) = ":86:" Then
                    omschrijving$ = omschrijving$ + Mid(hulp$, 5, Len(hulp$) - 4)
                    tel% = tel% + 1
                    hulp$ = regels(tel% + 1)
                    If Mid(hulp$, 1, 1) <> ":" Or Mid(hulp$, 1, 4) = ":86:" Then
                        If Mid(hulp$, 1, 4) <> ":86:" Then
                            omschrijving$ = omschrijving$ + " " + hulp$
                        Else
                            omschrijving$ = omschrijving$ + " " + Mid(hulp$, 5, Len(hulp$) - 4)
                        End If
                        
                        tel% = tel% + 1
                        hulp$ = regels(tel% + 1)
                            If Mid(hulp$, 1, 1) <> ":" Or Mid(hulp$, 1, 4) = ":86:" Then
                                If Mid(hulp$, 1, 4) <> ":86:" Then
                                    omschrijving$ = omschrijving$ + " " + hulp$
                                Else
                                    omschrijving$ = omschrijving$ + " " + Mid(hulp$, 5, Len(hulp$) - 4)
                                End If
                                        
                                
                                tel% = tel% + 1
                                hulp$ = regels(tel% + 1)
                            
                                If Mid(hulp$, 1, 1) <> ":" Or Mid(hulp$, 1, 4) = ":86:" Then
                                    If Mid(hulp$, 1, 4) <> ":86:" Then
                                        omschrijving$ = omschrijving$ + " " + hulp$
                                    Else
                                        omschrijving$ = omschrijving$ + " " + Mid(hulp$, 5, Len(hulp$) - 4)
                                    End If
                                        
                                
                                        tel% = tel% + 1
                                End If
                                                    
                            
                            
                            
                            
                            
                            
                            End If
                          
                    End If
                    
                    
                Else
                    If omschrijving$ = "" Then omschrijving$ = " "
                
                End If
                tel% = tel% + 1
                
                'modus = 6
                
                
                If optie% = 0 Or optie% = 1 Then
                    Call rijaan
                    Call uitlijning(centreer)
                    Call data(valdatum$, "")
                    Call data(boekdata$, "")
                    Call data(debcred$, "")
                    Call uitlijning(rechts)
                    Call data(bedrag$ + "  ", "")
                    Call uitlijning(links)
                    Call data(omschrijving$, "")
                    Call rijuit
                Else
                    bedrag$ = Replace(bedrag$, ".", Chr$(44))
                    naarcsv$ = kop$ + Chr$(34) + valdatum$ + Chr$(34) + Chr$(59) + Chr$(34) + boekdata$ + Chr$(34) + Chr$(59) + Chr$(34) + debcred$ + Chr$(34) + Chr$(59) + Chr$(34) + bedrag$ + Chr$(34) + Chr$(59) + Chr$(34) + omschrijving$ + Chr$(34) + Chr$(13) + Chr$(10)
                    Call schrijfcsvweg(naarcsv$)
                End If
                
                
            Else
                    tel% = tel% + 1
            End If
            
            
            
                If tel% > oudtel% Then
                    If optie% = 0 Or optie% = 1 Then
                        Call tabeluit
                        Call startlinks
                        Call legeregel
                        Call legeregel
                        Call lijn
                        Call legeregel
                        Call legeregel
                        modus = 1
                    Else
                        'optie 2
                        modus = 1
                    End If
                End If
                
            Case Else
            
            
            
            
            
                tel% = tel% + 1
        End Select
            
           
    
    
    
    
    Else
        tel% = tel% + 1
    End If
    
 
    




Loop Until tel% >= (lijnnr% + 1)





If optie% = 0 Or optie% = 1 Then
    Call tabeluit
    Call bodyuit
    hoofdscherm.WebBrowser1.Navigate2 bestand$
End If

'
'indien optie 2, csv: sluit bestand
If optie% = 2 Then
    Close csvbes
End If




End Sub
Sub schrijfcsvweg(indat$)
For r% = 1 To Len(indat$)
    Put csvbes, , Chr$(Asc(Mid(indat$, r%, 1)))
Next r%


End Sub




Function convbedrag$(indat$)

If hoofdscherm.bedragstijl1.Checked = True Then
    duizendscheiding$ = "."
    centscheiding$ = ","
Else
    duizendscheiding$ = ","
    centscheiding$ = "."
End If

' bepaal locatie comma en verwijder nullen
hlp$ = ""
voorloopnul = True
lc% = 0
lcf% = 0
For r = 1 To Len(indat$)
    b$ = Mid(indat$, r, 1)
    Select Case b$
        Case "0"
            If Not voorloopnul Then
                hlp$ = hlp$ + b$
                lc% = lc% + 1
            End If
        Case "."
            hlp$ = hlp$ + centscheiding$
            lc% = lc% + 1
            lcf% = lc%
            voorloopnul = False
        Case Chr$(44)
            hlp$ = hlp$ + centscheiding$
            lc% = lc% + 1
            lcf% = lc%
            voorloopnul = False
        Case Else
            hlp$ = hlp$ + b$
            lc% = lc% + 1
            voorloopnul = False
    End Select

Next r

'indien er geen comma staat of er ge-eindigd word met comma (bv: zweede handelsbanken)
'dan scheidingsteken + 2 nullen toevoegen
If lcf% = 0 Then hlp$ = hlp$ + centscheiding$ + "00"


'nul toevoegen
If Len(hlp$) - lcf% = 1 Then hlp$ = hlp$ + "0"
If Len(hlp$) - lcf% = 0 Then hlp$ = hlp$ + "00"

'duizendtallen
a% = Len(hlp$)
If a% > 6 Then 'duizend
    hlp$ = Mid(hlp$, 1, a% - 6) + duizendscheiding$ + Mid(hlp$, a% - 5, 6)
    a% = a% + 1 'lengte neemt met 1 toe vanwege toegevoegde punt/comma
End If
'
If a% > 10 Then 'miljoen
    hlp$ = Mid(hlp$, 1, a% - 10) + duizendscheiding$ + Mid(hlp$, a% - 9, 10)
    a% = a% + 1
End If
'
If a% > 14 Then 'miljard
    hlp$ = Mid(hlp$, 1, a% - 14) + duizendscheiding$ + Mid(hlp$, a% - 13, 14)
    a% = a% + 1
End If

'nul voor de comma toevoegen indien er alleen centen zijn
If Len(hlp$) = 3 Then
    hlp$ = "0" + hlp$
End If


convbedrag$ = hlp$

End Function


Function convboekdatum$(indat$)

If hoofdscherm.datumstijl1.Checked = True Then
    convboekdatum$ = Mid(indat$, 3, 2) + "-" + Mid(indat$, 1, 2)
Else
    convboekdatum$ = Mid(indat$, 1, 2) + "-" + Mid(indat$, 3, 2)
End If

End Function


Function convdatum$(indat$)

If hoofdscherm.datumstijl1.Checked = True Then
    convdatum$ = Mid(indat$, 5, 2) + "-" + Mid(indat$, 3, 2) + "-" + Mid(indat$, 1, 2)
Else
    convdatum$ = Mid(indat$, 3, 2) + "-" + Mid(indat$, 5, 2) + "-" + Mid(indat$, 1, 2)
End If








End Function


